/*
    quad_ctrl Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "component/ahrs.h"
#include "module/xm_quadctrl.h"
#include "module/config.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Quad_t q;
Quad_CMD_t quad_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_quad_ctrl(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / QUAD_CTRL_FREQ;

  osDelay(QUAD_CTRL_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
	Quad_Init(&q,&Config_GetRobotParam()->quad_params,&quad_cmd,QUAD_CTRL_FREQ);
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    
	osMessageQueueGet(task_runtime.msgq.quad.eulr, &q.current_status.eulr, NULL, 0);
  osMessageQueueGet(task_runtime.msgq.quad.accl, &q.current_status.accl, NULL, 0);
  osMessageQueueGet(task_runtime.msgq.quad.gyro, &q.current_status.gyro, NULL, 0);
	osMessageQueueGet(task_runtime.msgq.quad.alt, &q.current_status.alt, NULL, 0);
	osMessageQueueGet(task_runtime.msgq.quad.vel, &q.current_status.vel_z, NULL, 0);
	osMessageQueueGet(task_runtime.msgq.quad.cmd, &quad_cmd, NULL, 0);

	Quad_Ctrl(&q,&quad_cmd);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}